﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Security;

    public class ViafirmaInboxClient
    {
        private static ViafirmaInboxClient cliente = null;

        private static string urlWS;
        private static string user;
        private static string pass;

        private ViafirmaInboxClient()
        {
        }

        /**
         * Retorna una nueva instancia de ViafirmaClient.
         */
        static public ViafirmaInboxClient GetInstance()
        {
            if (cliente == null)
            {
                throw new Exception("Cliente no inicializado. Debe llamar al metodo init.");
            }
            else
            {
                return cliente;
            }
        }

        public static void init(string url)
        {
            urlWS = url;
            cliente = new ViafirmaInboxClient();
        }
        
        public static void init(string url,string username,string key)
        {
            urlWS = url;
            user = username;
            pass = key;
            cliente = new ViafirmaInboxClient();
        }

        

        public ServiceWS getRemoteObject()
        {
            ServiceWS servicio = new ServiceWS(urlWS);
            
            Uri uri = new Uri(urlWS);
            //
            //
            if (user != null && !user.Equals("") && pass != null && !pass.Equals(""))
            {
                servicio.PreAuthenticate = true;
                NetworkCredential netCredential = new NetworkCredential(user, pass);
                ICredentials credentials = netCredential.GetCredential(uri, "Basic");
                servicio.Credentials = credentials;
            }
            else
            {
                servicio.PreAuthenticate = false;
            }

            
            
            return servicio;
        }
    }

    

